// Next.js API route support: https://nextjs.org/docs/api-routes/introduction
import axios from 'axios';
import { Cookies } from 'react-cookie';
import cookie from 'cookie';
import moment from 'moment';
import jwt from 'jsonwebtoken';
import { inspect } from 'util';
import FormData from 'form-data';
import multer from 'multer';

import { cors } from '../../../lib/cors';

const storage = multer.memoryStorage();
const upload = multer({ storage: storage });

export default async function handler(req, res) 
{
	console.log("API", "support", "attachment");
	await cors(req, res);

	return new Promise((resolve) => 
	{
		if(req.headers.cookie !== undefined)
		{
			const cookies = cookie.parse(req.headers?.cookie ? req.headers?.cookie : "");
	
			if(cookies.jwt !== undefined && cookies.jwt !== null)
			{
				var client_jwt_decoded = jwt.verify(cookies.jwt, process.env.JWT_SECRET_CLIENT);
				var crm_jwt = jwt.sign({ acc_number: client_jwt_decoded.acc_number }, process.env.JWT_SECRET_CRM, { noTimestamp: true });

				const path = `${ process.env.CRM_API_HOST }/lk/incident/RequestClient/UploadDocument?request_client_number=${ req.query.request_client_number }`;
				console.log("API", "support", "request", "path", path);

				console.log("HEADERS");
				console.log("*".repeat(50));
				console.log(req.headers);
				console.log("*".repeat(50));

				upload.single("file")(req, {}, err => 
				{
					const { file } = req;
					file.originalname = Buffer.from(file.originalname, 'latin1').toString('utf8');

					const data = new FormData();
					data.append("file", file.buffer, file.originalname);

					try
					{
						axios.post(path, data, 
						{
							headers: {
								"Content-Type": `multipart/form-data; boundary=${ data._boundary }`, 
								"Authorization": `Bearer ${ crm_jwt }`, 
							}, 
							withCredentials: true, 
						})
						.then((crm_response) => 
						{
							console.log("crm_response for", path);
							console.log(inspect(crm_response.data, true, null, true));
	
							res.status(200).json(crm_response.data);
							resolve();
						})
						.catch((error) => 
						{
							console.error("-".repeat(30), "error.response.data:");
							console.error(error.response.data);
	
							res.status(500).json(error.response.data);
							resolve();
						});
					}
					catch(e)
					{
						console.error(e);
						res.status(500).end(e);
						resolve();
					}
				});
			}
			else
			{
				res.status(403).send();
				resolve();
			}
		}
		else
		{
			res.status(403).send();
			resolve();
		}
	});
}

export const config = {
	api: {
		bodyParser: false
	}
}